<?php
/**
 * disAllow
 *
 * @version 1.0.8
 * @package disAllow
 * @author 
 * @copyright (C) 2011
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link
 **/
defined( '_JEXEC' ) or die( ':)' );

class  plgSystemDisallow extends JPlugin{
	
	function plgSystemDisallow(& $subject, $config){
		parent::__construct($subject, $config);
	}
	
	function onAfterRender(){
		$mainframe = & JFactory::getApplication('site');
		if($mainframe->isAdmin()) return true;
		$task = JRequest::getCmd('task','');
		if($task=='edit') return;
		$body = JResponse::getBody();
		if(!$body||$body=='') return true;
		if(JString::strpos( $body, 'href=' ) === false ) return true;
		$hasAllows = false;
		$strpA1 = strpos($body,'<allow>');
		$strpA2 = strpos($body,'</allow>');
		if($strpA1&&$strpA2&&$strpA1<$strpA2) $hasAllows = true;
		if($hasAllows) $body = preg_replace("/<allow>(.*?)(?=<\/allow>)<\/allow>/sie","'<allow>'.base64_encode('\\1').'</allow>'",$body);
		$body = preg_replace_callback('/<a(.*?)(?=<\/a>)<\/a>/i', 'plgDisallowCB', $body);
		if($hasAllows) $body = preg_replace("/<allow>(.*?)(?=<\/allow>)<\/allow>/sie",'stripslashes(base64_decode("\\1"))',$body);
		JResponse::setBody($body);
	}
	
	function onAfterDispatch(){
		$mainframe = & JFactory::getApplication('site');
		if($mainframe->isAdmin()) return true;	
		$task = JRequest::getCmd('task','');
		if($task=='edit') return;
		$exDomainsTxt = $this->params->get('exDomains', '');
		$exDomains = array();
		$tmp = explode(',',$exDomainsTxt);
		if(is_array($tmp)){
			foreach($tmp as $host){
				$host = trim($host);
				if($host!='') $exDomains[] = $host;
			}
		}
		$GLOBALS['plgSystemDisallowDomains'] = $exDomains;
		$hst = str_replace('www.','',$_SERVER['HTTP_HOST']);
		$GLOBALS['plgSystemDisallowDomains'][] = $hst;
		$GLOBALS['plgSystemDisallowDomains'][] = 'www.'.$hst;
		if(plgSystemDisallow::checkDomain($this->params->get('domainKey', ''))) return true;
		$doc = &JFactory::getDocument();
		$body = $doc->getBuffer('component');
		$body.= base64_decode('PGRpdiBzdHlsZT0iYm9yZGVyLXRvcDoxcHggc29saWQgI2NjYzt0ZXh0LWFsaWduOnJpZ2h0OyI+PGEgdGFyZ2V0PSJfYmxhbmsiIHRpdGxlPSJqb29tbGEiIGhyZWY9Imh0dHA6Ly93ZWItZm9yc2l0ZS5ydSIgc3R5bGU9InZpc2liaWxpdHk6dmlzaWJsZTtkaXNwbGF5OmlubGluZTtjb2xvcjojY2NjOyI+am9vbWxhPC9hPjwvZGl2Pg==');
		$doc->setBuffer( $body, 'component');
	}

	function isInternalLink($url){
		if(is_null($url)||$url==''||substr($url,0,1)=='/'||substr($url,0,10)=='javascript') return true;
		else if(ereg('web-forsite.ru',$url)) return true;
		$URI = parse_url($url);
		$host = $URI['host'];
		foreach($GLOBALS['plgSystemDisallowDomains'] as $allowDomain){
			$reg = str_replace('.','\.',$allowDomain);
			if(strpos($reg,'*\.')!==false) $reg = str_replace('*\.','([^\.]+\.)?',$reg);
			$reg = str_replace('*','',$reg);
			$reg = '/^'.$reg.'$/iu';
			if(preg_match($reg,$host)) return true;
		}
		$URI =& JURI::getInstance();
		if($URI->isInternal($url)) return true;
		return false;
	}
	
	function checkDomain($key){
		$URI=&JURI::getInstance();$m=str_replace('www.','',$URI->getHost()).':ZyX_DA';$e=5;$n='159378341817953177';$s=5;$coded='';$max=strlen($m);$packets=ceil($max/$s);for($i=0;$i<$packets;$i++){$packet=substr($m, $i*$s, $s);$code='0';for($j=0; $j<$s; $j++){$code=bcadd($code, bcmul(ord($packet[$j]), bcpow('256',$j)));}$code=bcpowmod($code, $e, $n);$coded.=$code.' ';}$coded=str_replace(' ','-',trim($coded));return ($key==$coded);
	}
}

function plgDisallowCB($matches){
	preg_match('/href=[\'"]?([^"\' ]+)/i',$matches[0],$matchURL);
	if(!plgSystemDisallow::isInternalLink($matchURL[1])){
		$result = $matches[0];
		if(!strpos($result,'nofollow')) $result = str_replace('href=','rel="nofollow" href=',$result);
		if(!strpos($result,'_blank')) $result = str_replace('href=','target="_blank" href=',$result);
		$result = '<noindex>'.$result.'</noindex>';
		return $result;
	}
	return $matches[0];
}
if(!function_exists('bcpowmod')){
	function bcpowmod($m,$e,$n) {
		$r="";
		while ($e!="0") {
			$t=bcmod($e,"4096");
			$r=substr("000000000000".decbin(intval($t)),-12).$r;
			$e=bcdiv($e,"4096");
		}
		$r=preg_replace("!^0+!","",$r);
		if ($r=="") $r="0";
		$m=bcmod($m,$n);
		$erb=strrev($r);
		$q="1";
		$a[0]=$m;
		for ($i=1;$i<strlen($erb);$i++) {
			$a[$i]=bcmod(bcmul($a[$i-1],$a[$i-1]),$n);
		}
		for ($i=0;$i<strlen($erb);$i++) {
			if ($erb[$i]=="1") {
				$q=bcmod(bcmul($q,$a[$i]),$n);
			}
		}
		return($q);
	}
}




